package ihm;
import logique.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

import javax.swing.border.*;
import tools.*;
/** CheckDialog est un panneau permettant de remplir
 * les valeurs des attributs d'une balise 
 * ex:
 * <img src="CheckDialog.gif"> 
 * Ce widget gere le fait que la valeur de l'attribut de la balise 
 * doivent provenir d'une liste ou pas 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class CheckDialog extends JScrollPane
{
	
private MainFrame _master;
private JViewport _window;
private Tag _tag;
/**
 * LigneAttributIHM 
 * est une classe interne reprente une ligne ( zone de choix , description de l'attribut)
 */
public class LigneAttributIHM 
{
	
private String _name;
private String _value;
private JTextField _textfield ;
private MainFrame _master;
private  String extend(String s,int max)
{
int taille=s.length();
String result=new String(s);
if (taille<max) 
for (int h=taille;h<max;h++) result=result+new String("_");
return result;

}
/**
 * Le constructeur prend en parametre la fenetre de l'application 
 * et permet d'editer une valeur d'attribut
 * @param la fenetre mere de l'application 
 * @param name le nom de l'attribut
 * @param value la valeur de l'attribut(doit etre a null si l'attribut n'a pas de valeur)
 * @param clause doit etre a 2 si l'attribut est du type FIXED
 * @param p_name l'emplacement du panneau d'incription du nom de la balise
 * @param p_icon l'emplacement de l'icone de la ligne
 * @param p_value l'emplacement du panneau d'affichage des valeur
 */
public LigneAttributIHM(MainFrame master,String name ,String value,int clause,
JPanel p_name,JPanel p_icon,JPanel p_value)
{
_name=new String(name);
_master=master;
if (value!=null) _value=new String(value);
JLabel najme=new JLabel(_name);
p_name.add(najme);
_textfield=new JTextField(value,25);
if (clause==2) {_textfield.setEditable(false);};
DocumentListener myListener=new DocumentListener()
{
 public void changedUpdate(DocumentEvent e) 
 { 
 	 _value=new String(_textfield.getText());
         _tag.get(_name)._value=_value;
          new Thread(){
           		public void run()
           		{
           			 	_master.UpDateListe();
           			 	}
           		}.start();
 }
         
public void insertUpdate(DocumentEvent e) {  LogFile.println(e.toString());
_value=new String(_textfield.getText());
           		  LogFile.println("Valeur "+_value);
           		 _tag.get(_name)._value=_value;
           		 new Thread(){public void run(){_master.UpDateListe();}}.start();}
public void removeUpdate(DocumentEvent e) {  LogFile.println(e.toString());
_value=new String(_textfield.getText());
           		  LogFile.println("Valeur "+_value);
           		 _tag.get(_name)._value=_value;
           		 new Thread(){
           		public void run()
           		{
           			 	_master.UpDateListe();
           			 	}
           		}.start();}
};
_textfield.getDocument().addDocumentListener(myListener);
 JLabel t;
if (clause==1) {
		t=new JLabel(new ImageIcon("required.gif")); }
		else
if (clause==2) {t=new JLabel(new ImageIcon("fixed.gif"));}
        else   {
        	t=new JLabel(new ImageIcon("implied.gif"));	}
       
       
       p_icon.add(t);


     
p_value.add(_textfield);



//add(new JLabel(AttributDecl.getTypeS(clause)));

}
/**
 * Ce constructeur permet d'editer un attribut pouvant prendre un valeur 
 * parmis un certain nombre
 * @param la fenetre mere de l'application 
 * @param name le nom de l'attribut
 * @param value la valeur de l'attribut(doit etre a null si l'attribut n'a pas de valeur)
 * @param clause doit etre a 2 si l'attribut est du type FIXED
 * @param valueListe represente la liste des valeurs possible pour la ligne
 * @param p_name l'emplacement du panneau d'incription du nom de la balise
 * @param p_icon l'emplacement de l'icone de la ligne
 * @param p_value l'emplacement du panneau d'affichage des valeur
 */
public LigneAttributIHM(MainFrame master,String name ,String value,int clause,Vector valueListe
,JPanel p_name,JPanel p_icon,JPanel p_value)
{     _master=master;

_name=new String(name);

if (value!=null) _value=new String(value);
//if (clause==1) valueListe.add(new String("None"));

JLabel najme=new JLabel(_name);
p_name.add(najme);

final JComboBox listcb = new JComboBox(valueListe);
String selected=null;
for (int i=0;i<valueListe.size();i++)
{
selected=(String )valueListe.get(i);
if (selected.equals(value)) break;
}
if (selected!=null) listcb.setSelectedItem(selected);
 ActionListener listact= new ActionListener()
	{
	public void actionPerformed(ActionEvent e) 
           {
           _value=new String((String) listcb.getSelectedItem()); 
           if (_value.equals("None")) _tag.get(_name)._value=new String();
           else _tag.get(_name)._value=_value;
            new Thread(){
           		public void run()
           		{ LogFile.println("On update avec "+_value);
           			 	_master.UpDateListe();
           			 	}
           		}.start();
           		
           }
	};
	listcb.addActionListener(listact);
 JLabel t;
if (clause==1) {
		t=new JLabel(new ImageIcon("required.gif")); }
		else
if (clause==2) {t=new JLabel(new ImageIcon("fixed.gif"));}
        else   {
        	t=new JLabel(new ImageIcon("implied.gif"));	}
        p_icon.add(t);

     
p_value.add(listcb);


}



}
private Vector LigneAttributIHMListe;
/**
 * Le constructeur ,master est le nom de la fenetre mere
 * @param master la fenetre mere de l'application
 */
public CheckDialog(MainFrame master)
{super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	     setSize(300, 300);
	     _master=master;
_window=new JViewport();
setViewportView(_window);	     
	     
	}
/**
 * Initialise le widget avec un tag et une balise
 * @param b la balise contenant les valeur possible du tag
 * @param tag le tag a editer
 */
public void init(Balise b,Tag tag)
{
Vector v=b.getListeAttribut();
_tag=tag;
JPanel pp = new JPanel();
pp.setLayout(new BorderLayout());
JPanel checking = new JPanel(new BorderLayout());
JPanel p_name = new JPanel(new GridLayout(v.size(), 1, 10, 2));
JPanel p_icon = new JPanel(new GridLayout(v.size(), 1, 10, 2));
JPanel p_value = new JPanel(new GridLayout(v.size(), 1, 10, 2));
LigneAttributIHMListe=new Vector(10,10);
checking.setBorder(new TitledBorder(new EtchedBorder(), b.toString()));
 for (int i=0;i<v.size();i++)
 {
 AttributDecl tmp=(AttributDecl)v.get(i);
 Tag.AttributValue av=tag.get(tmp.getName());
 LigneAttributIHM lai;
if (tmp.getEnum()==false)
lai=new LigneAttributIHM(_master,tmp.getName(),av._value ,tmp.getType(),p_name,p_icon,p_value );
else
 lai=new LigneAttributIHM(_master,tmp.getName(),av._value ,tmp.getType(),tmp.getValueListe(),p_name,p_icon,p_value );
// p.add(lai);
LigneAttributIHMListe.add(lai);

 

}
checking.add(p_name, BorderLayout.WEST);
checking.add(p_icon, BorderLayout.EAST);
checking.add(p_value, BorderLayout.CENTER);


JPanel p2 = new JPanel(new GridLayout(1, 2, 10, 2));
JButton ck=new JButton("Delete Tag Group");
 ck.addActionListener(
	new ActionListener()
	{
	public void actionPerformed(ActionEvent e) 
           {
            LogFile.println(_master.removeGroup(_tag));
           CheckDialog.this.getViewport().setVisible(false);
           }
	});
JButton ck2=new JButton("Delete current Tag");
 ck2.addActionListener(
	new ActionListener()
	{
	public void actionPerformed(ActionEvent e) 
           {
            LogFile.println(_master.remove(_tag));
           CheckDialog.this.getViewport().setVisible(false);
           }
	});
		
//p2.add(ck);
p2.add(ck2);
p2.add(ck);
pp.add(p2,BorderLayout.SOUTH);
pp.add(checking, BorderLayout.NORTH);

  _window.add(pp);
  
  setVisible(false);
  setVisible(true);
  
}
}
