/*
 * 01/02/2001 - 15:44:49
 *
 * SplashScreen.java - Jext Splash Screen (also a class loader)
 * Copyright (C) 2002 Gros Pierre-Emmanuel
 * Copyright (C) 2000 Romain Guy (Version de base)
 * gros@limsi.fr
 * romain.guy@jext.org
 * www.jext.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 package ihm;
import logique.*;
import xml.*;
import myEvent.*;
import dialogtool.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import tools.*;
/**
 * represente la visualisation graphique des tags du document 
 */
 
public class ListeTagIhm extends JScrollPane implements MouseListener
{
transient ListeTagIhmListener listener;
	 
public static int NO_LIMIT=100;
public static int SIZE_TAG=NO_LIMIT;
public static int SIZE_TEXT=20;
public int _last;
class Couple
{
String _balise;
String _texte;
public String toString(){return new String("("+_balise+","+_texte+")");}
}
class MyCellRenderer extends JPanel implements ListCellRenderer {
     JButton frontIcon ;
     JButton backIcon ;
	JLabel un;
	JLabel deux;
	Font _font1;
	Font _font2;
     private String makeicon(String icon)
{
String result=new String("icons"+System.getProperty("file.separator")+icon);
return result;
}
     public Font AttributeToFont(SimpleAttributeSet attr)
     {
     String font=StyleConstants.getFontFamily(attr);
     int size=StyleConstants.getFontSize(attr);
    boolean bold=StyleConstants.isBold(attr);
    boolean italic=StyleConstants.isItalic(attr);
    int style=(bold?Font.BOLD:0);
    if (italic) style=style+Font.ITALIC;
    Font result=new Font(font,style,size);
    
     return result;
     }
     public MyCellRenderer(SimpleAttributeSet font1,SimpleAttributeSet font2)
     {
     super(new FlowLayout(FlowLayout.LEFT,
          0,0));un=new JLabel(/*LEFT*/);
   	deux=new JLabel(/*LEFT*/);  
   	
        if (font1!=null && font2!=null){
_font1=AttributeToFont(font1);
_font2=AttributeToFont(font2);
un.setForeground(StyleConstants.getForeground(font1));
deux.setForeground(StyleConstants.getForeground(font2));
un.setBackground(StyleConstants.getBackground(font1));
deux.setBackground(StyleConstants.getBackground(font2));
// LogFile.println("construct font1"+_font1);
// LogFile.println("construct font2"+_font2);

          }
      	  setBackground(Color.white);
      	  setForeground(Color.black);
     frontIcon = new JButton(new ImageIcon(makeicon("front.gif")));
      backIcon = new JButton(new ImageIcon(makeicon("back.gif")));
  
   
   	}
     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {
         
          setComponentOrientation(list.getComponentOrientation());
        
	if (isSelected) {
	    setBackground(list.getSelectionBackground());
	    setForeground(list.getSelectionForeground());
	}
	else {
	    setBackground(list.getBackground());
	    setForeground(list.getForeground());
	}
	setEnabled(list.isEnabled());
	//setBorder((cellHasFocus) ? UIManager.getBorder("List.focusCellHighlightBorder") : noFocusBorder);

         Couple s=(Couple)value;
         
       if (isSelected) un.setText(s._balise); else un.setText(s._balise);
         if (_font1!=null) un.setFont(_font1);
         
         add(un);
         
         deux.setText(s._texte);
         if (_font2!=null) deux.setFont(_font2);
         add(deux);  
        
       
         
         
         
    
    
         return this;
     }
 }



/**
 * la liste graphique 
 */
protected JList _liste;
/**
 * la liste des tag
 */
protected ListeTag _tag;
protected BaliseNode [] _bnode;
protected boolean _both ;
SimpleAttributeSet _mfont1;
SimpleAttributeSet _mfont2;
Tag lasttag;
int lastindex;
boolean flipflop;
public void setBoth(boolean both) 
{
	_both=both;
getViewport().setView(_liste);

//setVisible(true);

  
}
public void setFont1(SimpleAttributeSet font1){_mfont1=font1;}
public void setFont2(SimpleAttributeSet font2){_mfont2=font2;}
/**
 * constructeur de la classe , on passe la fenetre mere en parametre
 */
public ListeTagIhm()
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
setSize(600, 400);

_liste=new JList();
getViewport().setView(_liste);
_both=true;
//setVisible(true);

}


/**
 * mets a jour le composant avec une liste de tag
 */
public void SetTag(ListeTag tag,String document,DTDTree dtdtree)
{
lastindex=0;flipflop=true;
lasttag=null;
_liste.clearSelection();
XmlNode xmlnode=new XmlNode();
xmlnode.Init(tag,dtdtree);
_bnode=xmlnode.getNode();
// LogFile.println("ListeTagIhm::SetTag _both"+_both);

_liste=null;
_tag=tag;
Vector test=new Vector(10,10);
int decal=0;
BaliseNode work;
for (int i=0;i<_bnode.length;i++)
 {
  LogFile.println("_bnode"+i);

 Couple couple=new Couple();
   String affiche=new String();
 	
 	work=_bnode[i];
 	if (work.IsDebut())
 	{
 	decal=decal+2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getDebutStringBalise();
 	int taille=work.getTag().getFin()-work.getTag().getDebut();
 	if (taille>ListeTagIhm.SIZE_TEXT) taille=ListeTagIhm.SIZE_TEXT;
 	/* TODO verifier la taille max */
 	couple._balise=new String(affiche);
 	couple._texte=(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	affiche=affiche+(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	test.add(couple);
 	}
	else
	{decal=decal-2;
	if (_both){
	
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getFinStringBalise();
	couple._balise=new String(affiche);
	test.add(couple);}
}

}
 LogFile.println("LISTETAGIHM un"+test);
if (test.size()==0) _liste=new JList(); else _liste=new JList(test);
 LogFile.println("LISTETAGIHM deux"+_mfont1);
 LogFile.println("LISTETAGIHM trois"+_mfont2);
if (!_both)
{
BaliseNode [] tmp=new BaliseNode[_bnode.length/2];
int index=0;
for (int i=0;i<_bnode.length;i++) if (_bnode[i].IsDebut()) tmp[index++]=_bnode[i];
_bnode=tmp;
}
_liste.setCellRenderer(new MyCellRenderer(_mfont1,_mfont2));
getViewport().setView(_liste);
//setVisible(true);

  
    LogFile.println(" avant addMouseListener");
  
_liste.addMouseListener(this);
    LogFile.println(" apres addMouseListener");

repaint();
    LogFile.println(" apres listetagihminitaddMouseListener");

}
public void mouseClicked(MouseEvent e) {
  try
  {         int index = _liste.locationToIndex(e.getPoint()); 
   LogFile.println("ListeTagIhm::mouseListner::mouseCliked"+_both+"index"+index+"MODIFIER"+e.getModifiers()+" "+InputEvent.BUTTON2_MASK+" "+InputEvent.BUTTON1_MASK+" "+InputEvent.BUTTON3_MASK);
        if (index==-1 || (e.getModifiers()&InputEvent.BUTTON2_MASK)==InputEvent.BUTTON2_MASK || (e.getModifiers()&InputEvent.BUTTON3_MASK)==InputEvent.BUTTON3_MASK)
        {
        ListeTagIhmEvent bd1 ;
  bd1 = new ListeTagIhmEvent(this,ListeTagIhmEvent.SEMANTIQUE_NONSELECTIONNE); 
  Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd1);
        return ;
        }
             Tag t;
             // LogFile.println(_bnode[index].getTag());
             if (_bnode[index].IsDebut()) t=_bnode[index].getTag();
             	else t=_bnode[index].getSoeur().getTag();
          
             	long time=System.currentTimeMillis();
             	 LogFile.println("tag clicke"+t);
    if (lastindex!=index){
            try{  
     	    
             // LogFile.println("Double clicked on Item " + index);
             flipflop=true;
            lasttag=null;
            lastindex=index;
             /*_master.select(t);
             _master.viewLigne(t.getLigne());*/
               ListeTagIhmEvent bd = new ListeTagIhmEvent(this, t,t.getLigne(),ListeTagIhmEvent.SEMANTIQUE_SELECTIONNE);
            Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
             
     } catch (Exception ve) { LogFile.println(ve);};}
else {   LogFile.println("bouton 2 apparue"); 
	ListeTagIhmEvent bd ;
	if (flipflop)  bd = new ListeTagIhmEvent(this, t,t.getLigne(),ListeTagIhmEvent.SEMANTIQUE_ACTIF2); else
	 {bd = new ListeTagIhmEvent(this, t,t.getLigne(),ListeTagIhmEvent.SEMANTIQUE_ACTIF);}
	 flipflop=!flipflop;
	  lastindex=index;
	  lasttag=t;
            Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
            }
  }
  catch (Exception evc) 
  {
  ListeTagIhmEvent bd ;
  bd = new ListeTagIhmEvent(this,ListeTagIhmEvent.SEMANTIQUE_NONSELECTIONNE); 
  Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
  }
 };
public void mouseEntered(MouseEvent e) {} 
public void mouseExited(MouseEvent e) {}
public void mousePressed(MouseEvent e) {}
public void mouseReleased(MouseEvent e)  {}

public void select (Tag t)
{
 LogFile.println("ListeTagIhm::select"+t+"_both"+_both);

for (int i=0;i<_bnode.length;i++)
{
if (_bnode[i].getTag().equals(t)) {_liste.setSelectedIndex(i);


 JScrollBar _scroll=getVerticalScrollBar();
  if (_scroll==null) return;
  int max=_scroll.getMaximum();
  int nb_ligne=_liste.getLastVisibleIndex();
  int fligne=_liste.getFirstVisibleIndex();
  if (i>=fligne && i<=nb_ligne) return ;
 // LogFile.println("Scroll max:"+max+" valeur de i "+i+"nombre de ligne"+nb_ligne);
  int nvalue=(i*max)/nb_ligne;
 //  LogFile.println("Valeur de scroll : "+nvalue);
 Dimension d=getViewport().getExtentSize();
  int modulo=max/d.height;
 //  LogFile.println(getViewport().getViewSize());
//   LogFile.println(getViewport().getExtentSize());
 //  LogFile.println("position de la vue"+getViewport(). getViewPosition());
  Point p=getViewport().getViewPosition();
  
  

  if ((nvalue-d.height/2)<0)  nvalue=0;
  else nvalue=nvalue-d.height/2;
  _scroll.setValue(nvalue);
    repaint();
    return;      




}
}        
}
public synchronized void addListeTagIhmListener(ListeTagIhmListener l)
       /* throws TooManyListenersException*/ {
            /*if (listener != null) {
                throw new TooManyListenersException();
            }*/
            listener = l;
        }

    // Override processEvent() to handle new event type
    protected void processEvent(AWTEvent evt) {
        if (evt instanceof ListeTagIhmEvent) {
            processListeTagIhmEvent((ListeTagIhmEvent)evt);
            return;
        }
        super.processEvent(evt);
    }

    // Method for processing new event type
    protected void processListeTagIhmEvent(ListeTagIhmEvent evt) {
        if (listener != null) {
            listener.ListeTagIhmChange(evt);
        }
    }
    
}
