/*
 * 01/02/2001 - 15:44:49
 *
 * SplashScreen.java - Jext Splash Screen (also a class loader)
 * Copyright (C) 2002 Gros Pierre-Emmanuel
 * Copyright (C) 2000 Romain Guy (Version de base)
 * gros@limsi.fr
 * romain.guy@jext.org
 * www.jext.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 package ihm;
import logique.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import tools.*;
public class MyDefaultStyleDocument extends DefaultStyledDocument implements  DocumentListener

          
{
ListeTag _tag;
MainFrame _master;
MyDefaultStyleDocument(ListeTag t,MainFrame master) 
{
super();
_tag=t;
_master=master;
}
public void setListeTag(ListeTag lt)
 {
 _tag=lt;

 }       
MyDefaultStyleDocument(AbstractDocument.Content c, StyleContext styles,ListeTag t,MainFrame master) 
{
super(c,styles);
_tag=t;
_master=master;
addDocumentListener(this);
}
          
MyDefaultStyleDocument(StyleContext styles,ListeTag t,MainFrame master)  
{
super(styles);
_tag=t;
_master=master;
addDocumentListener(this);
}
public void changedUpdate(DocumentEvent e) 
{ 	
}

public void insertUpdate(DocumentEvent e) 
{
long profile=System.currentTimeMillis();
    //   LogFile.println("insertUpdate(DocumentEvent)"+e);
      int taille=e.getLength(); 
      int where=e.getOffset();
       _tag.AddText(where,taille,getNbLigne(where,where+taille));
      
	  _master.UpDateTag();
}
public  void removeUpdate(DocumentEvent e) 
{  	long profile=System.currentTimeMillis();
     // LogFile.println("removeUpdate"+e);
      int taille=e.getLength(); 
      int where=e.getOffset();
       LogFile.println("removeUpdate (taille:"+taille+"where:"+where+")");
      
      _tag.RemoveText(where,taille,getNbLigne(where,where+taille));
      
        _master.UpDateListe();
}
 


public void ApplyForAll(MutableAttributeSet attr)
{long profile=System.currentTimeMillis();	
//LogFile.println("97 ApplyForAll"+(System.currentTimeMillis()-profile));
if (Thread.currentThread() == getCurrentWriter()) {/* LogFile.println("problem\n");*/writeUnlock();}
else {/* LogFile.println("no problem\n");*/}
writeLock();
//LogFile.println("101 ApplyForAll"+(System.currentTimeMillis()-profile));

Element[] routelem=getRootElements();
//LogFile.println("104 ApplyForAll"+(System.currentTimeMillis()-profile));
int index_debut_change=-1;
int index_fin_change=-1;
for (int i=0;i<routelem.length;i++)
{
ElementIterator it = new ElementIterator(routelem[i]);
   	LogFile.println("108 ApplyForAll"+(System.currentTimeMillis()-profile));	
		      
Element elem; 

while ((elem = it.next()) != null) {
	//LogFile.println(elem);
	MutableAttributeSet oldattr = (MutableAttributeSet) elem.getAttributes();
	//LogFile.println("atribut de comparaison"+elem.getAttributes().copyAttributes()+" cette attribut "+attr+"comparaison "+oldattr.containsAttributes(attr));
   	//LogFile.println(oldattr+" "+oldattr.getClass().getName());
   	if (oldattr.containsAttributes(attr)==false){
   	if (index_debut_change==-1 || index_debut_change>=elem.getStartOffset()) index_debut_change=elem.getStartOffset();
   	if (index_fin_change==-1 || index_fin_change<=elem.getEndOffset()) index_fin_change=elem.getEndOffset();
   	
   	
   	oldattr.removeAttributes(oldattr);
  	oldattr.addAttributes(attr) ;
  	DefaultDocumentEvent e = new DefaultDocumentEvent(elem.getStartOffset(), elem.getEndOffset(),
					      DocumentEvent.EventType.CHANGE);
	e.end();
//	LogFile.println("124 ApplyForAll"+(System.currentTimeMillis()-profile));
	fireChangedUpdate(e);
  	}
           
	} 
	//LogFile.println("118 ApplyForAll"+(System.currentTimeMillis()-profile));
	}
/*LogFile.println(" ApplyForAll"+(System.currentTimeMillis()-profile)+"debut="+index_debut_change+"&fin="+index_fin_change);

	LogFile.println("126 ApplyForAll"+(System.currentTimeMillis()-profile));*/
	writeUnlock();
}

public boolean  setAttributeSet(MutableAttributeSet attrM,int debut,int fin) 
{

   long profile=System.currentTimeMillis();	
 LogFile.println("setAttributeSet(MutableAttributSet debut fin)");
    if ( debut != fin)
    {
    setCharacterAttributes(debut, fin - debut, attrM, false);
    // LogFile.println("End of setAttributeSet(MutableAttributSet debut fin)"+(System.currentTimeMillis()-profile));

        return true;

} 

  return false;
  
}

 
/** 
 * gere l'ajout dans le document 
 */
protected void insertUpdate(AbstractDocument.DefaultDocumentEvent chng,
                            AttributeSet attr)
      {super.insertUpdate(chng,attr);
     
	// LogFile.println("End of insertUpdate(DocumentEvent)"+(System.currentTimeMillis()-profile));
	
      }
/**
 * gere le retrait de caractere dans le document 
 */
protected void removeUpdate(AbstractDocument.DefaultDocumentEvent chng)

       {
       	super.removeUpdate(chng);
     
        // LogFile.println("End of insertUpdate(DocumentEvent)"+(System.currentTimeMillis()-profile));
	
       


}
public void setTag(ListeTag t){_tag=t;}
 /**
   * rend le nombre de ligne entre le caractere debut et le caractere fin"
   */
    public int getNbLigne(int debut,int fin)
    {
    
     int un=getLigne(debut);
     int deux=getLigne(fin);
     if (un>deux) return (un-deux); else return (deux-un);
    
}



/**
 * donne le numero de la ligne du charactere l
 */
   public int getLigne(int l)
  {
  	int index=0;

	Element element=getCharacterElement(l);
	
	index=getDefaultRootElement().getElementIndex(l) ;
          
  return index;
  }
}