
 
package ihm;
import logique.*;
import xml.*;
import myEvent.*;
import style.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import tools.*;
/**
 * 12-05-03 <br>
 *
 * Table des preferences <br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class TabbedPreference extends JDialog  
{
	 transient PreferenceListener listener;
/**
 * 12-05-03 <br>
 *
 * gere les preferences de fichiers <br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
	public class FilePreference extends JPanel 
	{
	JLabel _workingfolder;
	JLabel _default_dtd;
	JLabel _default_style;
	JTextField _default_dtd_field;
	JTextField _workingfolder_field;
	JTextField _default_style_field;
	String dtdfile;
	/**
	 * Constructeur
	 */
	public FilePreference()
	{
	super(new GridLayout(3,1));
	JPanel p=new JPanel(new GridLayout(1,2));
	
	_workingfolder=new JLabel("Working Folder");
	_default_dtd=new JLabel("Default DTD");
	_default_style=new JLabel("Default Style");
	_default_dtd_field=new JTextField();
	_workingfolder_field=new JTextField();
	_default_style_field=new JTextField();
	p.add(_workingfolder);
	p.add(_workingfolder_field);
	add(p);
	 p=new JPanel(new GridLayout(1,2));
	
	p.add(_default_dtd);
	p.add(_default_dtd_field);
	add(p);
	 p=new JPanel(new GridLayout(1,2));
	
	p.add(_default_style);
	p.add(_default_style_field);
	add(p);
	dtdfile=new String();
}
/**
 * renvoie le repertoire par defaut
 */
public String getDefaultDirectorie()
{String result=_workingfolder_field.getText();
if (result!=null) return result; else return "";
}
/**
 * renvoie la DTD par defaut
 */
public String getDTDFile()
{String result=_default_dtd_field.getText();
if (result!=null) return result; else return "";
}
/**
 * renvoie le style par default
 */
public String getDefaultStyle()
{String result=_default_style_field.getText();
if (result!=null) return result; else return "";
}
/**
 * initialise l objet
 * @param s : la DTD par defaut
 * @param s1: le repertoire par defaut
 * @param s2: le fichier par defautl
 */
public void init(String s,String s1,String s2)
 {
 	LogFile.println("TabbedPreference::init(String "+s+")");
 _default_dtd_field.setText(s);
 _workingfolder_field.setText(s1);
 _default_style_field.setText(s2);
 }
};
/**
 * preference concerant les styles
 */
	public class StylePreference extends JPanel  implements ActionListener, FontPanelListener
	{
	private JComboBox _type_de_text;
	private String selection;
	private String [] choiceStyle;
	private FontDialog fd;
	SimpleAttributeSet SampleText;
	SimpleAttributeSet TagBody;
	SimpleAttributeSet PlainText;
	/**
	 * renvoie le vecteur de couleur par defautl
	 */
	public Vector GetDefaultColor(){return fd.GetDefaultColor();}
	/**
	 * renvoie l attribut graphique pour le plain text
	 */
	public SimpleAttributeSet getPlainText(){return PlainText;}
	/**
	 * renvoie un style graphique par defaut
	 */
	public SimpleAttributeSet getDefault()
	{
	SimpleAttributeSet result=new SimpleAttributeSet();
	StyleConstants.setForeground(result, Color.black);
	StyleConstants.setBackground(result,Color.white);
	StyleConstants.setFontSize(result,12);
	return result;
	}
	/**
	 * constructeur
	 */
	public StylePreference()
	{
	super(new BorderLayout());
	
	
	
	
  	
	JPanel select_attr=new JPanel(new GridLayout(3,2,10,2));
	select_attr.setBorder(new TitledBorder(new EtchedBorder(), "Effects"));
  	JPanel select_color=new JPanel(new GridLayout(2,2,10,2));
  	select_color.setBorder(new TitledBorder(new EtchedBorder(), "Colors"));
  	
	String [] m_font=GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
		
  	String []  m_fontSizes = new  String[] {"8", "9", "10", "11", "12", "14",
      "16", "18", "20", "22", "24", "26", "28", "36", "48", "72"}; 
      	 choiceStyle=new String[] {"Plain Text","Tag Body","Sample Text"};
      	selection=new String(choiceStyle[0]);
     fd=new FontDialog();
     fd.init(m_font,m_fontSizes);
     fd.addFontPanelListener(this);
   	    _type_de_text=new JComboBox(choiceStyle);
   	   	
   	  
   	      _type_de_text.addActionListener(this);
   	   
   	    add(_type_de_text,BorderLayout.NORTH);
   	    add(fd,BorderLayout.CENTER);
   	    
   	    
   	    
 	SampleText=getDefault();
	 TagBody=getDefault();
	 PlainText=getDefault();
	 
   	    
	}
	
private  SimpleAttributeSet TextToAttr(String s)
{
if (s.equals(choiceStyle[0])) return PlainText;
if (s.equals(choiceStyle[1])) return TagBody;
if (s.equals(choiceStyle[2])) return SampleText;
return null;
}
/**
 * gere le changement de font 
 */
 public void FontChanged(FontPanelEvent evt)
 {
 LogFile.println("SELECTION******:"+selection);
   	   	if (selection.equals(choiceStyle[0]))
   	   	{ 
   	   		PlainText=evt.getAttribute(); LogFile.println("cas 1 plaintext:"+PlainText);
   	   	}
   	   	else if (selection.equals(choiceStyle[1]))
   	   	{ 
   	   	TagBody=evt.getAttribute(); LogFile.println("cas 3 TagBody:"+TagBody);}
   	   	else 
   	   	{
   	   	
   	   	SampleText=evt.getAttribute();  LogFile.println("cas 4 SampleText:"+SampleText);
 }

   	
}
/**
 * rend visible le panneau
 */
public void setVisible(boolean b)
{
super.setVisible(b);
fd.setAttributes(TextToAttr(selection));
}
	public  void actionPerformed(ActionEvent e)
   	   	{
   	   	
   	   	String s=(String)_type_de_text.getSelectedItem();
   	   	fd.set_example(s,TextToAttr(s));
   	   	fd.setAttributes(TextToAttr(s));
   	   	 selection=new String(s);	
   	   };
   	   
   	   
/** 
 * met a jour les attribut de plain text
 */   	   
public void setAttributesPlainText(SimpleAttributeSet a) {PlainText=a;}
/**
 * met a jour les attributs de tag body
 */
public void setAttributesTagBody(SimpleAttributeSet a) {TagBody=a;}
/**
 * met a jour les attribut des examples
 */
public void setAttributesSampleText(SimpleAttributeSet a) {SampleText=a;}
/**
 * donne les attributs du plain text
 */
public SimpleAttributeSet getAttributesPlainText() {return PlainText;}
/**
 * rend les attribut des tag body
 */
public SimpleAttributeSet getAttributesTagBody() {return TagBody;}
/**
 * rend les attributs des examples
 */
public SimpleAttributeSet getAttributesSampleText() {return SampleText;}



	
	



}
/**
 * gere les preferences d options 
 */
public class OptionPreference extends JPanel
	{
		private JCheckBox m_endingBalise;
		private JCheckBox m_strictDTD;
		
		private JComboBox m_sizetext;
		private JComboBox m_sizebalise;
		
		public OptionPreference()
		{
		super(new GridLayout(1,2,10,2));
		m_endingBalise=new JCheckBox("Ending Balise");
		m_strictDTD=new JCheckBox("Strict DTD Tree??");
		add(m_endingBalise);
		add(m_strictDTD);String []  m_fontSizes = new  String[] {"5", "10", "15", "20", "25", "30",
      "35", "40", "45", "50"}; 
		m_sizetext=new JComboBox(m_fontSizes);
		m_sizebalise=new JComboBox(m_fontSizes);
		JPanel un =new JPanel(new GridLayout(2,1,10,2));
		JPanel toto=new JPanel(new FlowLayout());
		toto.add(new JLabel("size of Text in Xml Zone"));
		toto.add(m_sizetext);
		/******** TODO GERER LES TAILLES DIFFERENTES ***/
		//un.add(toto);
		toto=new JPanel(new FlowLayout());
		toto.add(new JLabel("size of Tag in Xml Zone"));
		toto.add(m_sizebalise);
		//un.add(toto);
		/*un
		un.add(new JComboBox(m_fontSizes));*/
		add(un);
		pack();
      
		}	
	public JCheckBox getEndingBaliseOption(){return m_endingBalise;}
	public JCheckBox getStrictDTDOption(){return m_strictDTD;}
	public int getSizeBalise(){return Integer.parseInt((String)m_sizebalise.getSelectedItem());}
	public int getSizeText(){return Integer.parseInt((String)m_sizetext.getSelectedItem());}
	}
  	
private JTabbedPane _tabbedPane;
private FilePreference _filepreference;
private StylePreference _stylepreference;
private OptionPreference _optionpreference;
private JPanel _panel;
private JButton save;
private JButton cancel;
private JButton ok;
private JButton apply;
private JScrollPane scrollpane;

private int x;
private int y;
private int width ;
private int height;
public boolean getBoth(){return _optionpreference.getEndingBaliseOption().isSelected();}
public void setBoth(boolean b){ _optionpreference.getEndingBaliseOption().setSelected(b);}
public boolean getStrictDTD(){return _optionpreference.getStrictDTDOption().isSelected();}
public void setStrictDTD(boolean b){ _optionpreference.getStrictDTDOption().setSelected(b);}

public void setAttributesPlainText(SimpleAttributeSet a) {_stylepreference.setAttributesPlainText(a);}
public void setAttributesTagBody(SimpleAttributeSet a) {_stylepreference.setAttributesTagBody(a);}
public void setAttributesSampleText(SimpleAttributeSet a) {_stylepreference.setAttributesSampleText(a);}
public GraphicStyle getAttributesPlainText(){return (new GraphicStyle(_stylepreference.getAttributesPlainText()));}
public GraphicStyle getAttributesTagBody(){return (new GraphicStyle(_stylepreference.getAttributesTagBody()));}
public GraphicStyle getAttributesSampleText(){return (new GraphicStyle(_stylepreference.getAttributesSampleText()));}
public Vector getColorDefault(){return _stylepreference.GetDefaultColor();}
public String getDefaultDirectorie() {return _filepreference.getDefaultDirectorie();}
public String getDTDFile(){return _filepreference.getDTDFile();}
public String getDefaultStyle(){return _filepreference.getDefaultStyle();}
public  Preference getPreference()
{
	Preference pref=new Preference(getAttributesPlainText(),getAttributesTagBody(),getAttributesSampleText(),
 	getBoth(),getDefaultDirectorie(),getDTDFile(),getColorDefault(),getDefaultStyle(),getStrictDTD());
 	return pref;
}
public void makeit(Preference pref)
{  
 
 
 	
  	    PreferenceEvent bd = new PreferenceEvent(this, pref);
            Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(bd);
 
 
}
public TabbedPreference(JFrame j)
{
super(j,true);

x=0;
y=0;
width=0;
y=0;

_panel=new JPanel(new BorderLayout());
JPanel panel=new JPanel(new FlowLayout(FlowLayout.RIGHT));
_tabbedPane=new JTabbedPane();
_filepreference=new FilePreference();
_stylepreference=new StylePreference();
_optionpreference=new OptionPreference();
_tabbedPane.addTab("File", _filepreference) ;
_tabbedPane.addTab("Font",_stylepreference);
_tabbedPane.addTab("Option",_optionpreference);
_panel.add(_tabbedPane,BorderLayout.CENTER);
cancel=new JButton("Cancel");
save=new JButton("Save");
ok=new JButton("ok");
apply=new JButton("Apply");

ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
         Preference pref=getPreference();
         makeit(pref);
         setVisible(false);
      }
    };
   
     ActionListener lst3 = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
          
        setVisible(false);
      }
    };
    ActionListener lst4 = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
       Preference pref=getPreference();
        makeit(pref);
         try
         {
         
String result=new String("preferences"+System.getProperty("file.separator")+"xmljava.conf");

         PrintWriter out=new PrintWriter(new FileWriter(result));
        // ReadPreference.writePreference(out,TabbedPreference.this);
       pref.WriteXML(out);
         out.flush();
         out.close();
         }catch (IOException ee){LogFile.println(ee);}
        setVisible(false);
      }
    };

    ok.addActionListener(lst);
     save.addActionListener(lst4);
  
    cancel.addActionListener(lst3);
panel.add(cancel);
panel.add(ok);

panel.add(save);
_panel.add(panel,BorderLayout.SOUTH);

scrollpane=new JScrollPane(_panel);
getContentPane().add(scrollpane);
pack();

}



public void init(Preference pref)
 {
  LogFile.println("TabbedPane::init()");
if (pref!=null){
  setBoth(pref.getBoth());
   setStrictDTD(pref.getStrictDTD());
 
  if (pref.getAttributesPlainText()!=null) setAttributesPlainText( pref.getAttributesPlainText().getAttributes());
  if (pref.getAttributesTagBody()!=null) setAttributesTagBody( pref.getAttributesTagBody().getAttributes());
 if (pref.getAttributesSampleText()!=null)  setAttributesSampleText(pref.getAttributesSampleText().getAttributes());
 if (pref.getDTDFile()!=null && pref.getDefaultDirectorie()!=null && pref.getDefaultStyle()!=null) _filepreference.init(pref.getDTDFile(),pref.getDefaultDirectorie(),pref.getDefaultStyle());
 }
 }

public void setVisible(boolean b)
{

super.setVisible(b);
scrollpane.setVisible(b);

}
 public void addNotify() 
 {
 super.addNotify();

 pack();
 }

public synchronized void addPreferenceListener(PreferenceListener l)
       /* throws TooManyListenersException*/ {
            /*if (listener != null) {
                throw new TooManyListenersException();
            }*/
            listener = l;
        }

    // Override processEvent() to handle new event type
    protected void processEvent(AWTEvent evt) {
        if (evt instanceof PreferenceEvent) {
            processPreferenceEvent((PreferenceEvent)evt);
            return;
        }
        super.processEvent(evt);
    }

    // Method for processing new event type
    protected void processPreferenceEvent(PreferenceEvent evt) {
        if (listener != null) {
            listener.PreferenceChanged(evt);
        }
    }
    
}