
package ihm;
import logique.*;
import xml.*;
import org.xml.sax.ext.DeclHandler;
import org.xml.sax.*;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.SAXException;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import tools.*;



import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
/*
 * 12-05-03 <br>
 *
 * Affiche le resultat d une validation Xml<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59
 * Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 * XmlValidator represente une fenetre de validation
 * d 'un document XML 
 * Cette Boite de dialogue affiche le document genere en Xml
 * Essaye de le valider et affiche le resultat de la validation 
 */

public class XmlValidator extends JDialog
{
 private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";

private XMLReader parser;
/**
 * desktop gere l'affichage du document XML
 */
protected JDesktopPane desktop;
/**
 * m_monitor affiche le document Xml
 */
protected JTextPane m_monitor;
/**
 * m_doc est le document XML proprement dit 
 */
protected DefaultStyledDocument m_doc;
/**
 * m_kit gere l'affichage RTF du document XML
 */
protected StyledEditorKit m_kit;
  
/**
 * m_monitor2 gere l'affichage du resultat de la compilation
 */  
protected JTextPane m_monitor2;
/**
 * m_doc2 est le document affiche representant le resultat de la compilation
 */
protected DefaultStyledDocument m_doc2;
/**
 * m_kit2  gere l'affichage RTF du document valider
 */
protected StyledEditorKit m_kit2;
protected JScrollPane scrollpane;

/**
 * La classe DTDValid permet de valider le document
 */
public class DTDValid extends DefaultHandler  {
protected String _message;
protected boolean _error;
/**
 * Initialise l objet
 */
   public DTDValid(){_message=new String("Perfect Compilation");_error=false;}
   /**
    * retourne l etat de la validation
    * @result true si la validation est correct
    */ 
   public boolean IsError(){return _error;}
   /**
    * renvoie le message d erreur
    * @result : le message d erreur
    */
   public String getMessage(){return _message;}
    public void attributeDecl( String eName, String aName,String 
                               type, String valueDefault, String value ) throws SAXException{}

    
    public void elementDecl( String name, String model ) throws SAXException {}
    public void internalEntityDecl (String name, String value) throws SAXException{}

    public  void externalEntityDecl (String name, String publicId,String systemId) throws SAXException {}
public void warning(SAXParseException ex)  {
       _message=new String("[Warning] Ligne:"+
                           (new Integer(ex.getLineNumber())).toString()+
           
                           ex.getMessage());
       _error=true;
    }

    /** Error. */
    public void error(SAXParseException ex) {
        _message=new String("[Error] Ligne:"+
                           (new Integer(ex.getLineNumber())).toString()+
           
                           ex.getMessage());
        _error=true;
    }

    /** Fatal error. */
    public void fatalError(SAXParseException ex) throws SAXException {
        _message=new String("[Fatal Error] Ligne:"+
                           (new Integer(ex.getLineNumber())).toString()+
           
                           ex.getMessage());
	_error=true;                           
        throw ex;
    }
}
/**
 * le constructeur prend la fenetre mere de l'application en parametre
 */
 public  XmlValidator(MainFrame mainframe) 
  {
  super(mainframe, "Validation du XML") ;
  //parser=new SAXParser();
  try{ parser = (XMLReader)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  }catch (Exception q) {LogFile.println(q);}

  scrollpane=new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	
	setSize(600, 400);
 	m_monitor = new JTextPane();
 	m_kit = new StyledEditorKit();
  	m_monitor.setEditorKit(m_kit);
	m_doc = new DefaultStyledDocument(new StyleContext());
   	m_monitor.setDocument(m_doc);
   m_monitor.setDoubleBuffered(true);
   
   m_monitor2 = new JTextPane();
 	m_kit2 = new StyledEditorKit();
  	m_monitor2.setEditorKit(m_kit2);
	m_doc2 = new DefaultStyledDocument(new StyleContext());
   	m_monitor2.setDocument(m_doc2);
   m_monitor2.setDoubleBuffered(true);
	
	JSplitPane _split2=new JSplitPane(JSplitPane.VERTICAL_SPLIT,m_monitor,m_monitor2);

	
scrollpane.setViewportView(_split2);	
scrollpane.setVisible(true);
  getContentPane().setLayout(new BorderLayout());
    getContentPane().add(scrollpane, BorderLayout.CENTER);
  Action ok = new AbstractAction("",new ImageIcon("ok.gif"))
{ 
	public void actionPerformed(ActionEvent e) 
	{
	setVisible(false);
	};
};

  
getContentPane().add(new JButton(ok), BorderLayout.SOUTH);
   
  }
  
/**
 * Test test une chaine de caractere representant le document XML
 */
  public void Test(String filename,boolean strict)
  {
   try
   {  
   MutableAttributeSet attr=new SimpleAttributeSet();
//StyleConstants.setForeground(attr, Color.black);
StyledDocument doc=m_monitor.getStyledDocument();
int taille=doc.getLength();
           
 doc.remove(0, taille) ;
           
doc.insertString(0,filename,attr);

StyledDocument doc2=m_monitor2.getStyledDocument();
int taille2=doc2.getLength();
           
 doc2.remove(0, taille2) ;
           


InputSource buff=new InputSource(new StringBufferInputStream(filename));
 // parser.setProperty( "http://xml.org/sax/properties/declaration-handler",new DTDValid());

     parser.setFeature( "http://xml.org/sax/features/validation",
                                                strict);
            parser.setFeature( "http://xml.org/sax/features/namespaces",
                                                strict );
            parser.setFeature( "http://apache.org/xml/features/validation/schema",
                                                strict );
            parser.setFeature( "http://apache.org/xml/features/validation/schema-full-checking",
                                                strict );

     DTDValid handler = new DTDValid();

     parser.setContentHandler(handler);
     parser.setErrorHandler(handler);                                           
   parser.parse( buff );
 doc2=m_monitor2.getStyledDocument();
doc2.insertString(0,handler.getMessage(),attr);
  }

catch (SAXParseException e) {
	try
{ String mess=new String(e.getMessage() +"\nligne:"+e.getLineNumber()); 
MutableAttributeSet attr=new SimpleAttributeSet();
StyledDocument doc2=m_monitor2.getStyledDocument();
doc2.insertString(0,mess,attr);
StyledDocument doc=m_monitor.getStyledDocument();
int debut=0;
int i=0;
int deb=0;
for (;i<filename.length();i++) 
{ if (filename.charAt(i)=='\n') debut++;
  if (debut==e.getLineNumber()) deb=i;

  if (debut>e.getLineNumber()) break;
}

MutableAttributeSet result=new SimpleAttributeSet();
StyleConstants.setBackground(result, Color.red);    
                           
doc.setCharacterAttributes(deb,i,result,true);


repaint();
}
catch (Exception b){}}
catch (Exception ee) { LogFile.println(ee); 
try
{
MutableAttributeSet attr=new SimpleAttributeSet();
StyledDocument doc2=m_monitor2.getStyledDocument();
doc2.insertString(0,ee.toString(),attr);
repaint();
}
catch (Exception b){}
}

}}
