package logique;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import org.xml.sax.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;

/**
 * ListeBalise reprensente le vecteur des balises de la dtd du document 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */

 public class ListeBalise extends Vector implements XmlSerialisable
{

        public ListeBalise()
{
super(10,10);
}
/**
 * setDefaultStyle met a jour le style des balises de la liste<br>
 * si ecrase est vrai le style est remplace , sinon il est fusionn
 * @param s la valeur de style de mise a jour
 * @param ecrase vrai si on veut remplacer le style courant des balises
 */
public void setDefaultStyle(SimpleAttributeSet s,boolean ecrase)
{
int taille=size();
for (int i=0;i<taille;i++)  ((Balise)get(i)).UpDateAttributDefault(s,ecrase);

}
/**
 * getBaliseByOrder renvoie la balise dont l'identification correspond au numero d'ordre
 * @param order le numero d'ordre de la balise
 * @result la balise dont l'ordre correspond a order(null si inexistant)
 */
public Balise getBaliseByOrder(int order)
{
int taille=size();
for (int i=0;i<taille;i++) 

if ( ((Balise)get(i)).getOrder()==(order)) return ((Balise)get(i));
return null;

}
/**
 * renvoie la balise dont le nom est passer en parametre
 * @param s le nom de la balise
 * @result la balise correspondant au nom s (null si inexsitant)
 */
public Balise getBaliseByName(String s)
{
int taille=size();
for (int i=0;i<taille;i++) if ( ((Balise)get(i)).getName().equals(s)) return ((Balise)get(i));
return null;
}

public EnsembleStyle getEnsembleStyle(String s)
{
EnsembleStyle ensemble=new EnsembleStyle(s);
int taille=size();
for (int i=0;i<taille;i++)
{Style st=((Balise)get(i)).getStyle(s);
ensemble.AddStyle(((Balise)get(i)).getName(),st);

}
return ensemble;
}
public boolean changeStyle(String s)
{
int taille=size();
for (int i=0;i<taille;i++)
{((Balise)get(i)).changeStyle(s);
}
return true;
}
public void AddStyle(EnsembleStyle s)
{
int taille=size();
for (int i=0;i<taille;i++)
{
	Balise b=(Balise)get(i);
	Style st=s.get(b.getName());
	if (st==null) st=new Style();
	b.AddStyle(s.getStyleName(),st);
	
}


}

public void AddStyle(String s)
{
int taille=size();
for (int i=0;i<taille;i++)
{((Balise)get(i)).AddStyle(s);
}
}


public String getXMLName(){return "listebalise";}
public void WriteXML(PrintWriter out)
{
out.write("<listebalise>");
for (int i=0;i<size();i++) ((Balise)get(i)).WriteXML(out);
out.write("</listebalise>");
}
public void lectXML(Attributes attributes,Vector construct)
{
for (int i=0;i<construct.size();i++) 
add(construct.get(i));
}
}
