
 package logique;

import org.xml.sax.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import tools.*;
/**
 * 01/02/2001 - 15:44:49
 *
 * Preference.java 
 * Copyright (C) 2002 Gros Pierre-Emmanuel
 * 
 * gros@limsi.fr
 * 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * Represente la structuration logique des preferences
 *
 */
public class Preference implements XmlSerialisable
{
private Vector _colorDefault;
private String _defaultDirectorie;
private String _dtdfile;
private String _default_style;
private GraphicStyle _plainText;
private GraphicStyle _tagbody;
private GraphicStyle _sampleText;
private boolean _both;
/**
 * doit t on afficher la balise de fin
 */
public boolean getBoth(){return  _both;}
private boolean _strictDTD;
/**
 * l arbre de DTD doit il etre complet
 */
public boolean getStrictDTD(){return  _strictDTD;}
/**
 * Style graphic pour le texte
 */
public GraphicStyle getAttributesPlainText(){return  _plainText;}
/**
 * style graphics pour les tags
 */
public GraphicStyle getAttributesTagBody(){return  _tagbody;}
/**
 * style graphic pour les text exemple
 */
public GraphicStyle getAttributesSampleText(){return  _sampleText;}
/**
 * renvoie les couleurs par defauts
 */
public Vector getColorDefault(){return  _colorDefault;}
/**
 * renvoie le repertoire par defaut
 */
public String getDefaultDirectorie() {return  _defaultDirectorie;}
/**
 * renvoie le fichier de DTD par defaut
 */
public String getDTDFile(){return  _dtdfile;}
/**
 * renvoie le style par defaut
 */
public String getDefaultStyle(){return _default_style;}
/**
 * constructeur pour etre XmlSerialisable
 */
public Preference(){}
/**
 * constructeur 
 */
public Preference(GraphicStyle plainText,GraphicStyle tagBody,GraphicStyle sampleText,
		  boolean both,String defaultDirectorie,String dtdFile,Vector color,String defaultstyle,boolean strictDTD)
		  {
		  _plainText=plainText;
		  _tagbody=tagBody;
		 _strictDTD=strictDTD;
		  _sampleText=sampleText;
		  _colorDefault=color;
		  _defaultDirectorie=defaultDirectorie;
		  _dtdfile=dtdFile;
		  _both=both;
		  _default_style=new String(defaultstyle);
		}
/** 
 * renvoie le nom de la classe en Xml
 */
public String getXMLName(){return "preference";}
/**
 * ecrit l objet vers du Xml
 */
public void WriteXML(PrintWriter out)
{
out.write("<preference directorie=\""+_defaultDirectorie+"\" dtdfile=\""+_dtdfile+"\" both=\""+_both+"\" defaultstyle=\""+_default_style+"\" strictDTD=\""+_strictDTD+"\" >");
_plainText.WriteXML(out);
_tagbody.WriteXML(out);
_sampleText.WriteXML(out);
for (int i=0;i<_colorDefault.size();i++) {myColor c=new myColor((Color)_colorDefault.get(i)); c.WriteXML(out);}
out.write("</preference>");

}
/**
 * lit un objet en Xml
 */
public void lectXML(Attributes attributes,Vector construct)
{
_defaultDirectorie=attributes.getValue("directorie");
_dtdfile=attributes.getValue("dtdfile");
if (attributes.getValue("both")!=null) _both=(attributes.getValue("both")).equals("true");
if (attributes.getValue("strictDTD")!=null) _strictDTD=(attributes.getValue("strictDTD")).equals("true");
System.err.println(attributes.getValue("strictDTD")+_strictDTD);
_default_style=attributes.getValue("defaultstyle");
 LogFile.println("construct 0"+construct.get(0).getClass().getName());
_plainText=(GraphicStyle)construct.get(0);
 LogFile.println("construct 1"+construct.get(1).getClass().getName());
_tagbody=(GraphicStyle)construct.get(1);
 LogFile.println("construct 2"+construct.get(2).getClass().getName());
_sampleText=(GraphicStyle)construct.get(2);
_colorDefault=new Vector();
for (int i=3;i<construct.size();i++)
{
_colorDefault.add(((myColor)construct.get(i))._color);
}
}


}