
 
package logique;
import java.util.*;
import java.io.*;
import tools.*;
/**
 * 12-05-03 <br>
 *
 * Represente un tag Xml<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * Represente un tag dans un document
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class Tag implements Serializable
{
/**
 * represente une valeur d'un attribut d'un tag dans un document
 */
public class AttributValue implements Serializable
{
/**
 * le nom de l'attribut
 */
public String _name;
/** 
 * la valeur de l'attribut
 */
public String _value;
/** 
 * renvoie le nom de lattribut
 * @result le nom de l'attribut 
 */
public String getName(){return _name;}
/**
 * renvoie la valeur de cette attribut
 * @result la valeur de l'attribut 
 */
public String getValue(){return _value;}
/**
 * constructeur de la classe AttributValue 
 * @param name le nom de l'attribut 
 * @param value la valeur de l'attribut 
 */
public AttributValue(String name,String value)
{if (name!=null) _name=new String(name);
if (value!=null) _value=new String(value);}
/**
 * met a jour la valeur de l'attribut 
 * @param value la nouvelle valeur 
 */
public void setValue(String value) {_value=new String(value);}

public String toString()
{	if (_name==null || _value==null ||_value.equals(""))
	return "";
	else return (new String (" "+_name+"=\""+_value+"\""));
}
private void writeObject(java.io.ObjectOutputStream out)
     throws IOException
     {
     	out.writeUTF(_name);
     	out.writeUTF(_value);
     }
private void readObject(java.io.ObjectInputStream in)
     throws IOException, ClassNotFoundException
     {
     	_name = in.readUTF();
	_value = in.readUTF();
     	}
 


}
/** 
 * la balise contenant les information logique sur le tag
 */
protected Balise _balise;
 /**
  * caractere de debut du tag
  */
protected int _debut;
/**
 * caractere de fin de tag
 */
protected int _fin;
/**
 * est ce un tag valide (reserver)
 */
protected boolean _isdead;
/**
 * la liste des attribut du tag
 */
protected Vector AttributValues;
/**
 * renvoie le numero de ligne du tag
 */
protected int _nb_ligne;
public String toString()
{
String result=new String(_balise.toString()+" debut:"+_debut+" fin:"+_fin+"_nb_ligne"+_nb_ligne);
return result;
}

/**
 * renvoie le nombre d'attribut du tag
 * @result le nombre d'attribut du tag
 */
public int nbAttribut(){return AttributValues.size();}
private void writeObject(java.io.ObjectOutputStream out)
     throws IOException
     {
     	out.writeObject(_balise);
     	out.writeInt(_debut);
     	out.writeInt(_fin);
     	out.writeBoolean(_isdead);
     	out.writeObject(AttributValues);
     	out.writeInt(_nb_ligne);
     	
     	
     }
private void readObject(java.io.ObjectInputStream in)
     throws IOException, ClassNotFoundException
     {
     	_balise=(Balise)in.readObject();
     	 LogFile.println("BALISE LUT"+_balise);
     	_debut=in.readInt();
     	_fin=in.readInt();
     	_isdead=in.readBoolean();
     	AttributValues=(Vector)in.readObject();
     	_nb_ligne=in.readInt();
}
/**
 * cosntructeur par defaut 
 */
public Tag(){};
/**
 * constructeur de la classe Tag
 * @param b la balise contenant les information sur le tag
 * @param debut le caractere de debut du tag
 * @param fin le caractere du de fin de tag
 * @param nb_ligne le numero de ligne du tag
 */
public Tag(Balise balise,int debut,int fin,int nb_ligne)
{
_isdead=false;
_balise=balise;
_debut=debut;
_fin=fin;
_nb_ligne=nb_ligne;
Vector listattr=balise.getListeAttribut();
AttributValues=new Vector(0,0);
for (int i=0;i<listattr.size();i++)
{
 LogFile.println(i);
 LogFile.println(listattr.get(i));
AttributDecl atdl=(AttributDecl)listattr.get(i);
AttributValues.add(new AttributValue(atdl.getName(),atdl.getValue()));
}

}
/**
 * renvoie faux si le tag est valide
 * @result faux si le tag est valide
 */
public boolean IsDead(){return _isdead;}
/** 
 * met a jour la valeur de l'attribut dead
 * @param dead la nouvelle valeur
 */
public void SetDead(boolean dead) {_isdead=dead;}
/**
 * renvoie la balise associe au tag
 * @result la balise associ
 *
 */

public void setBalise(Balise b){
Vector listattr=b.getListeAttribut();
Vector AttributValuestmp=new Vector(0,0);
for (int i=0;i<listattr.size();i++)
{
AttributDecl atdl=(AttributDecl)listattr.get(i);
AttributValuestmp.add(new AttributValue(atdl.getName(),atdl.getValue()));
}
for (int  i=0;i<AttributValues.size();i++)
{
	AttributValue y=((AttributValue)AttributValues.get(i));
	// LogFile.println("Check for attribute "+y._name+"value"+y._value);
		for (int j=0;j<AttributValuestmp.size();j++) 
		if (((AttributValue)AttributValuestmp.get(j))._name.equals(y._name)) 
		{
			((AttributValue)AttributValuestmp.get(j))._value=new String(y._value);
			break;
		}
}
AttributValues=AttributValuestmp;
_balise=b;
	 
}
public Balise getBalise(){return _balise;}
public int getDebut(){return _debut;}
public int getFin(){return _fin;}
public int getLigne(){return _nb_ligne;}
public boolean getTagAtDebutOrEnd(int debutorend)
{
return (debutorend==_debut || debutorend==_fin);
}

public AttributValue get(int i)
{
	return (AttributValue)AttributValues.get(i);
}
/**
 * gere le fait que l'on a ajouter un morceau de texte
 * a l'offset offset de taille taille  la ligne ligne 
 * @param offset le debut ou on a ajouter du texte
 * @param taille la taille du morceau a ajouter
 * @param ligne la ligne ou en a ajouter
 */
public void AddText(int offset,int taille,int ligne,boolean byXml)
{
if (!byXml)
{
 LogFile.println("Addtext :(debut,fin):"+_debut+","+_fin+" (offset taille ): "+offset+","+taille);
if (offset<=_debut) {_debut=_debut+taille;_fin=_fin+taille;}
else
{if (offset>_debut && offset<_fin ) _fin=_fin+taille;}
}
else
{
 LogFile.println("Addtext byxml :(debut,fin):"+_debut+","+_fin+" (offset taille ): "+offset+","+taille);
if (offset<_debut) {_debut=_debut+taille;_fin=_fin+taille;}
else
{if (offset>=_debut && offset<=_fin ) _fin=_fin+taille;}
}

}
/**
 * gere le fait que l'on a enlever un morceau de texte
 * a l'offset offset de taille taille  la ligne ligne 
 * @param offset le debut ou on a enlever du texte
 * @param taille la taille du morceau a enveler
 * @param ligne la ligne ou en a enlever
 */
public void RemoveText(int offset,int taille,int ligne)
{
 LogFile.println("RemoveText Tag("+_debut+","+_fin+")"+ "RemoveText("+offset+","+taille+")");
if (offset<=_debut && (offset+taille)<=_debut) { LogFile.println("cas1");_debut=_debut-taille;_fin=_fin-taille;} else
if (offset<=_debut && (offset+taille)<_fin && (offset+taille)>_debut) { LogFile.println("cas2");_debut=offset;_fin=_fin-taille;} else
if (offset>_debut && (offset+taille)<=_fin) { LogFile.println("cas3");_fin=_fin-taille;}else
//if (offset>_debut && (offset+taille)>_fin) {_fin=offset;}else
if (offset<_debut && (offset+taille)>_fin) { LogFile.println("cas4");SetDead(true);}


}

public  AttributValue createAttributValue(String sname,String svalue)
{
AttributValue result=new AttributValue(sname,svalue);
return result;
}
/**
 * renvoie vrai si je couvre la distance offset,offset+taille
 * @param offset le debut de la couverture
 * @param taille la taille de la couverture
 */
public boolean IsDead(int offset,int taille)
{
return (offset<=_debut && (offset+taille)>=_fin) ;
}
/**
 * renvoie le ieme attribut du tag
 * @result une instance de classe de AttributValue
 */
public AttributValue get(String i)
{
	for (int j=0;j<AttributValues.size();j++) 
	if (((AttributValue)AttributValues.get(j))._name.equals(i)) return ((AttributValue)AttributValues.get(j));
	return null;
}
/**
 * met a jour un attribut du nom name avec la valeur value pour ce tag
 * @param name le nom de l'attribut 
 * @param value la valeur de l'attribut
 */
public void  setValue(String name,String value)
{
	for (int j=0;j<AttributValues.size();j++) 
	if (((AttributValue)AttributValues.get(j))._name.equals(name)) 
	{
		((AttributValue)AttributValues.get(j))._value=new String(value);
		return ;
	}
	return ;
}
public boolean Inside(int debut,int fin)
{
return debut<=_debut && fin>=_fin;
}
public boolean recouvre(int debut,int fin)
{
 LogFile.println("debut:"+debut+" fin:"+fin+" _debut:"+_debut+" _fin:"+_fin);
boolean result=(debut<=_debut && fin>=_fin)
	||     (debut>=_debut && fin<=_fin)
	||     (debut>=_fin && fin>=_fin)
	||     (debut<=_debut && fin<=_debut);
return (!result);
}
/**
 * renvoie vrai si le tag couvre caret
 * @param caret la position a tester
 * @result vrai si le tag couvre caret
 */
public boolean IsMe(int caret)
{
return (_debut<=caret && caret<=_fin);
}
public boolean IsMe(int debut,int fin)
{
boolean result=(debut>=_debut && fin<=_fin);
return result;
}
/**
 * renvoie la taille couverte par le tag
 * @result la taille
 */
public int getTaille(){return _fin-_debut;}
/**
 * renvoie une chaine de caractere representant le tag 
 * comme etant un tag de debut de balise XML
 * @result le texte correspondant 
 */
public String getDebutStringBalise()
{
String result=new String ("<"+_balise.getName());
for (int i=0;i<AttributValues.size();i++) 
{

	result=result+((AttributValue)AttributValues.get(i)).toString();
}
result=result+">";
return result;
}
/**
 * renvoie une chaine de caractere representant le tag 
 * comme etant un tag de debut et fin de balise XML
 * @result le texte correspondant 
 */
public String getDebutFinStringBalise()
{
String result=new String ("<"+_balise.getName());
for (int i=0;i<AttributValues.size();i++) result=result+((AttributValue)AttributValues.get(i)).toString();
result=result+"/>";
return result;
}
/**
 * renvoie une chaine de caractere representant le tag 
 * comme etant un tag de fin de balise XML
 * @result le texte correspondant 
 */
public String getFinStringBalise()
{
return (new String ("</"+_balise.getName()+">" ));
}
}