
 
package style;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import myEvent.*;
import logique.*;
import tools.*;
/*
 * 01/02/2001 - 15:44:49
 *
 * Panneau de style 
 * Copyright (C) 2002 Gros Pierre-Emmanuel
 * 
 * gros@limsi.fr
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *   @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
public class StylePanel extends JPanel implements FontPanelListener,SemantiquePanelListener
{
JTabbedPane _tabbedPane;
FontDialog _fontDialog;
SemantiqueStylePanel _semDialog;
FontPanelListener _listener;
SemantiquePanelListener _listenerSem;
public StylePanel()
{
super();
_tabbedPane=new JTabbedPane();
_fontDialog=new FontDialog(); LogFile.println("trace");
_semDialog=new SemantiqueStylePanel();
String []  m_fontNames = GraphicsEnvironment.
      getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
   String []  m_fontSizes = new  String[] {"8", "9", "10", "11", "12", "14",
      "16", "18", "20", "22", "24", "26", "28", "36", "48", "72"};
_fontDialog.init(m_fontNames,m_fontSizes);
_tabbedPane.add("GraphicsStyle",_fontDialog);
_tabbedPane.add("SemantiqueStyle",_semDialog);
add(_tabbedPane);

try
{
	_fontDialog.addFontPanelListener(this);
	_semDialog.addSemantiquePanelListener(this);
}
catch(Exception e){ LogFile.println(e);}
}
public void set(String s,logique.Style attr)
{
	SimpleAttributeSet at=attr.getGraphicStyle().getAttributes();
_fontDialog.set_example(s,at);
_fontDialog.setAttributes(at);
_semDialog.setAttributes(attr.getSemantiqueStyle());
}
public void addFontPanelListener(FontPanelListener listener)
{
_listener=listener;
}
/** 
 * ajoute une capture d evenement semantique
 */
public void addSemantiquePanelListener(SemantiquePanelListener listener)
{
_listenerSem=listener;
}
    public void FontChanged(FontPanelEvent evt)
    {
    	
     LogFile.println(evt);	
    _listener.FontChanged(evt);
    
}
/**
 * call back 
 */
public void SemantiqueChanged(SemantiquePanelEvent evt)
 {
    	
     LogFile.println(evt);	
    _listenerSem.SemantiqueChanged(evt);
    
}

 public static void main(String [] args)
 {
 JFrame h=new JFrame();
 h.getContentPane().add(new StylePanel());
 h.setVisible(true);
 }         
}