package tools;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.util.Calendar;
/**
 * 12-05-03 <br>
 *
 * LogFile permet de faire des bug reports (remplace System.err)<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 */
public class LogFile
{
/**
 * la sortie du fichier de log 
 */
 static PrintStream logfile=null;
  static long profile;
/**
 * initialise la classe apele par la classe si besoin
 */
public static synchronized  void init()
{
try{
if (logfile==null)
{ 
	
	Calendar calendar=Calendar.getInstance();
	String now=calendar.get(Calendar.DAY_OF_MONTH)+"_"+calendar.get(Calendar.MONTH)+"_"+calendar.get(Calendar.YEAR)+"_"+calendar.get(Calendar.HOUR_OF_DAY)+"_"+calendar.get(Calendar.MINUTE)+"_"+calendar.get(Calendar.SECOND)+"_"+calendar.get(Calendar.MILLISECOND);
        profile=System.currentTimeMillis();	 
	String filename=new String("bugreport"+System.getProperty("file.separator")+"xmljava_"+(now)+".log");
	FileOutputStream f=new FileOutputStream(filename);
	logfile=new PrintStream(f);
	
 }  }catch (Exception e ) {System.err.println(e);}
}
/**
 * voir class PrintStream pour renseignement
 */
public static synchronized  boolean checkError(){return logfile.checkError();}
public static synchronized  void close(){flush();logfile.close();}
public static synchronized  void flush(){logfile.flush();}
public static synchronized  void print(boolean b){if (logfile==null) init(); logfile.print(System.currentTimeMillis()-profile); logfile.print(b);logfile.flush();}
public static synchronized  void print(char c){if (logfile==null) init(); logfile.print(System.currentTimeMillis()-profile);logfile.print(c);logfile.flush();}
public static synchronized  void print(char[] s){if (logfile==null) init(); logfile.print(System.currentTimeMillis()-profile);logfile.print(s);logfile.flush();}
public static synchronized  void print(double d){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.print(d);logfile.flush();}
public static synchronized  void print(float f){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.print(f);logfile.flush();}
public static synchronized  void print(int i){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.print(i);logfile.flush();}
public static synchronized  void print(long l){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.print(l);logfile.flush();}
public static synchronized  void print(Object obj){if (logfile==null) init(); logfile.print(System.currentTimeMillis()-profile);logfile.print(obj);logfile.flush();}
public static synchronized  void print(String s){if (logfile==null) init(); logfile.print(System.currentTimeMillis()-profile);logfile.print(s);logfile.flush();}
public static synchronized  void println(){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println();logfile.flush();}
public static synchronized  void println(boolean x){if (logfile==null) init(); logfile.print(System.currentTimeMillis()-profile);logfile.println(x);logfile.flush();}
public static synchronized  void println(char x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(char[] x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(double x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(float x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(int x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(long x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(Object x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void println(String x){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.println(x);logfile.flush();}
public static synchronized  void write(byte[] buf, int off, int len) {if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.write(buf,off,len);logfile.flush();}
public static synchronized  void write(int b){if (logfile==null) init();logfile.print(System.currentTimeMillis()-profile); logfile.write(b);logfile.flush();}
};