package xml;
import logique.*;
import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import org.xml.sax.helpers.AttributesImpl;
import tools.*;
/**
 * 12-05-03 <br>
 *
 * serialiser vers du Xml<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * GeneralReader est un moteur de serialisation  generique vers du Xml
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 */
 
public class GeneralReader  extends DefaultHandler 
{
private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";
private Vector object_serialisable;
private Stack construct;
private Stack attribute;
private XmlSerialisable resultat;
/**
 * renvoie l objet lut a partir de la serialisation
 * @result un objet de type XmlSerialisable
 *
 */
public XmlSerialisable getResultat(){return resultat;}

/**
 * private but declared public for convenience
 */
public void startDocument() 
{
	resultat=null;
	construct=new Stack();
attribute=new Stack();
}

/**
 * private but declared public for convenience
 */

public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes) 
{
	
          
AttributesImpl at=new AttributesImpl(attributes) ;
attribute.push(at);
Stack tmp=new Stack();
construct.add(tmp);
 LogFile.println(localName+" "+at);
}
/**
 * private but declared public for convenience
 */
public void endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName) 
{
try{
 LogFile.println(localName);
XmlSerialisable ser=search(localName);
 LogFile.println("trouve le constructeur par default");
Constructor c=findDefault(ser.getClass());
 LogFile.println("Appel le constructeur par default");
XmlSerialisable nouveaux=(XmlSerialisable)c.newInstance(null);
Stack s=(Stack)construct.pop();
Vector args=new Vector();
while (!s.empty()) args.add(0,s.pop());
 LogFile.println("empile les arguments");
Attributes attr=(Attributes) attribute.pop();
 LogFile.println("lance la lecture");
nouveaux.lectXML(attr,args);
 LogFile.println(nouveaux);
if (construct.empty()) // c est finie 
resultat=nouveaux;
else 
{Stack tmp=(Stack)construct.peek();
tmp.push(nouveaux);
}
}
catch (Exception e){ LogFile.println(e);}                     
}
public Constructor findDefault(Class c)
{
Constructor[] listeconstruc=c.getConstructors();
for (int i=0;i<listeconstruc.length;i++) if (listeconstruc[i].getParameterTypes().length==0) return listeconstruc[i];
return null;
}
public XmlSerialisable search(String s)
{
for (int i=0;i<object_serialisable.size();i++)
{
XmlSerialisable ser=(XmlSerialisable)object_serialisable.get(i);
// LogFile.println(ser.getXMLName()+"=="+s);
if (ser.getXMLName().equals(s)) return ser;
}
return null;
}
/**
 * Constructeur du moteur
 */
public GeneralReader()
{
object_serialisable=new Vector();
construct=new Stack();
attribute=new Stack();
}
/**
 * Toutes les classe serialisable doivent etre enregistre ici
 * @param serialisable : un objet de type serialisable
 */
 
public void AddSerialisable(XmlSerialisable serialisable)
{
object_serialisable.add(serialisable);
}
/**
 * lit un flux d entree et deserialise un document
 */
public void lect(FileReader f) throws Exception
{
  SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  
parser.setContentHandler (this);
     parser.parse(new InputSource(f));
    
} 
public static void main(String args[]) 
{
 try{ SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  GeneralReader lo = new GeneralReader();
  lo.AddSerialisable(new GraphicStyle());
    lo.AddSerialisable(new logique.Style());
      lo.AddSerialisable(new SemantiqueRule());
parser.setContentHandler (lo);
     parser.parse(new InputSource(new FileReader(args[0])));
    }catch (Exception q) { LogFile.println(q);}
     
}
           
}