package xml;
import logique.*;
import tools.*;

import java.util.*;
/**
 * 12-05-03 <br>
 *
 * permet de generer du Xml<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * Genere un texte Xml a partir d un texte et des balises
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 */
public class GenerateXML 
{
/**
 * Tranforme un document en Html
 * @param document le texte
 * @param listetag la liste des tags
 * @param dtdfile le nom de fichier de dtd
 * @param dtdtree la forme logique de l arbre de DTD
 */
public static  String GenerateHTML(String document,ListeTag listetag, String dtdfile,DTDTree dtdtree)
{

String result=new String("<body bgcolor=\"#ffffff\">\n");
int taille=document.length();
Tag t;


XmlNode xmlnode=new XmlNode();
xmlnode.Init(listetag,dtdtree);
BaliseNode [] _bnode=xmlnode.getNode();
int taillebnode=_bnode.length;
 LogFile.println(taillebnode);
 LogFile.println(xmlnode);
int indexnode=0;
int debut=0;
int fin=0;
for (int i=0;i<taillebnode;i++)
{
 fin=_bnode[i].getIndex();
 String tmp=document.substring(debut,fin);
 for (int k=0;k<tmp.length();k++) if (tmp.charAt(k)=='\n') result=result+"<br>\n";else result=result+tmp.charAt(k);

 if (_bnode[i].IsDebut()) 
	{
	result=result+"<SPAN class=\""+_bnode[i].getTag().getBalise().getName()+"\">";
	}
	else result=result+"</SPAN>\n";
  debut=fin;
}
if (debut!=taille)
{
String tmp=document.substring(debut,taille);
 for (int k=0;k<tmp.length();k++) if (tmp.charAt(k)=='\n') result=result+"<br>\n";else result=result+tmp.charAt(k);

}
        
result=result+new String("</body>\n");

return result;
}
public static int getHeaderLength(){return 4;}
        /**
         * la fonction GenerateXML genere du Xml.Si le document n a pas de racine une racine "xmljava" est incluse @param le document sous forme de chaine de caractere
         * @param la liste des tags
         * @param le nom du fichier dtd 
         * @paramrenvoie le document XML 
         */
public static  String GenerateXML(String document,ListeTag listetag, String dtdfile,DTDTree dtdtree)
{
Calendar calendar=Calendar.getInstance();
String now=calendar.get(Calendar.DAY_OF_MONTH)+"_"+calendar.get(Calendar.MONTH)+"_"+calendar.get(Calendar.YEAR)+"_"+calendar.get(Calendar.HOUR_OF_DAY)+"_"+calendar.get(Calendar.MINUTE)+"_"+calendar.get(Calendar.SECOND)+"_"+calendar.get(Calendar.MILLISECOND);
String header=new String("<!-- version 9 6_1_2003 "+now+" -->\n");       
String newheader=new String("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE "+dtdtree.getRootElement()+" SYSTEM \""+dtdfile+"\">\n"+header );
String result=new String("");
int taille=document.length();
Tag t;


XmlNode xmlnode=new XmlNode();
xmlnode.Init(listetag,dtdtree);
BaliseNode [] _bnode=xmlnode.getNode();
int taillebnode=_bnode.length;
 LogFile.println(taillebnode);
 LogFile.println(xmlnode);
int indexnode=0;
int debut=0;
int fin=0;
//boolean bdebut=false;
boolean OK=false;
for (int i=0;i<taillebnode;i++){
if (_bnode[i].getIndex()==0 && _bnode[i].getSoeur().getIndex()==document.length()) {OK=true;break;}
if (_bnode[i].getIndex()==document.length() && _bnode[i].getSoeur().getIndex()==0) {OK=true;break;}
}
for (int i=0;i<taillebnode;i++)
{
 fin=_bnode[i].getIndex();
 
 result=result+document.substring(debut,fin);
 if (_bnode[i].IsDebut()) 
	{
	result=result+_bnode[i].getTag().getDebutStringBalise();
	}
	else
	{
	result=result+_bnode[i].getTag().getFinStringBalise();
	}
  debut=fin;
}
if (debut!=taille)
{
result=result+document.substring(debut,taille);
}
if (!OK) result=newheader+new String("<xmljava>")+result+new String("</xmljava>");
else result=newheader+result;


return result;
}
/**
 * ne sert a rien 
 */
public static  Vector GenerateXMLVector(String document,ListeTag listetag, String dtdfile,DTDTree dtdtree)
{
Vector result=new Vector(10,10);
Calendar calendar=Calendar.getInstance();
String now=calendar.get(Calendar.DAY_OF_MONTH)+"_"+calendar.get(Calendar.MONTH)+"_"+calendar.get(Calendar.YEAR)+"_"+calendar.get(Calendar.HOUR_OF_DAY)+"_"+calendar.get(Calendar.MINUTE)+"_"+calendar.get(Calendar.SECOND)+"_"+calendar.get(Calendar.MILLISECOND);
String header=new String("<!-- version 9 5_12_2003 "+now+" -->\n");       

result.add(new  String("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE personnel SYSTEM \""+dtdfile+"\">\n"+header ));
int taille=document.length();
Tag t;


XmlNode xmlnode=new XmlNode();
xmlnode.Init(listetag,dtdtree);
BaliseNode [] _bnode=xmlnode.getNode();
int taillebnode=_bnode.length;
 LogFile.println(taillebnode);
 LogFile.println(xmlnode);
int indexnode=0;
int debut=0;
int fin=0;
for (int i=0;i<taillebnode;i++)
{
 fin=_bnode[i].getIndex();
 result.add(new String(document.substring(debut,fin)));
 if (_bnode[i].IsDebut()) 
	{
	result.add(new String(_bnode[i].getTag().getDebutStringBalise()+"\n"));
	}
	else
	{
	result.add(new String(_bnode[i].getTag().getFinStringBalise()+"\n"));
	}
  debut=fin;
}
if (debut!=taille)
{
result.add(new String(document.substring(debut,taille)));
}
        

return result;
}
}