package xml;
import logique.*;
import tools.*;
import org.xml.sax.ext.DeclHandler;
import org.xml.sax.*;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.SAXException;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
/**
 * 12-05-03 <br>
 *
 * permet de tester du Xml<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * la classe XmlChecker permet de tester une chaine de caractere representant du xml
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 * 
 */
public class XmlChecker
{private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";


       /**
	* 12-05-03 <br>
	*
 	* Encapsulation de l erreur d un parsing Xml<br>
 	* Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 	* 
 	* gros@limsi.fr<br>
 	* 
 	* 
 	*
 	* This program is free software; you can redistribute it and/or<br>
 	* modify it under the terms of the GNU General Public License<br>
 	* as published by the Free Software Foundation; either version 2<br>
 	* of the License, or any later version.<br>
 	*
 	* This program is distributed in the hope that it will be useful,<br>
 	* but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
	* GNU General Public License for more details.<br>
 	*
 	* You should have received a copy of the GNU General Public License<br>
 	* along with this program; if not, write to the Free Software<br>
 	* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 	*
 	* la classe XmlCheckerInformation contient les informations d erreurs d un parsing Xml
 	*  @author Gros Pierre Emmanuel
 	*         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 	* @version 9.0
 	*
 	* 
 	*/
	public class XmlCheckerInformation
	{
	private int nb_ligne;
	private int nb_char;
	private String message;
	private boolean error;
	/**
	 * Constructeur par defaut 
	 * Invoque lorsque qu 'il n y a pas d erreur
	 */
	public XmlCheckerInformation(){error=false;}
	/**
	 * Constructeur lorqu'il y a des erreur
	 * @param nb_ligne: le numero de la ligne ou il y a eu l erreur
	 * @param nb_char : le numero du character ou lerreur a ete rencontre
	 * @param message: le message de l erreur
	 */
	public XmlCheckerInformation(int nb_ligne,int nb_char,String message)
		{this();error=true;this.nb_ligne=nb_ligne;this.nb_char=nb_char;this.message=new String(message);}
	/**
	 * renvoie vrai si le dernier parsing a inclus une erreur
	 * @result:vrai si on a eu une erreur
	 */
	public boolean getError(){return error;}
	
	/**
	 * renvoie le numero du character ou on trouve une erreur
	 * @result : le numero du charactere de l erreur
	 */
	 public int getNbChar(){return nb_char;}
	 /**
	 * renvoie le numero de la ligne ou on trouve une erreur
	 * @result : le numero de ligne de l erreur
	 */
	 public int getNbLigne(){return nb_ligne;}
	 /**
	 * renvoie message d erreur une erreur
	 * @result : le message  de l erreur
	 */
	 public String getMessage(){return message;}
	 
	}
	/**
	* 12-05-03 <br>
	*
 	* Dummy DTD handler tune pour valider<br>
 	* Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 	* 
 	* gros@limsi.fr<br>
 	* 
 	* 
 	*
 	* This program is free software; you can redistribute it and/or<br>
 	* modify it under the terms of the GNU General Public License<br>
 	* as published by the Free Software Foundation; either version 2<br>
 	* of the License, or any later version.<br>
 	*
 	* This program is distributed in the hope that it will be useful,<br>
 	* but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
	* GNU General Public License for more details.<br>
 	*
 	* You should have received a copy of the GNU General Public License<br>
 	* along with this program; if not, write to the Free Software<br>
 	* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 	*
 	* Dummy Handler pour valider
 	*  @author Gros Pierre Emmanuel
 	*         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 	* @version 9.0
 	*
 	* 
 	*/
	public class DTDValid extends DefaultHandler  {
	protected String _message;
	protected SAXParseException exception;
	protected boolean _error;
	public SAXParseException getException(){return exception;}
	public DTDValid(){_message=new String("Perfect Compilation");_error=false;}
   	public boolean IsError(){return _error;}
   	public String getMessage(){return _message;}
    	public void attributeDecl( String eName, String aName,String type, String valueDefault, String value ) throws SAXException{}
        public void elementDecl( String name, String model ) throws SAXException {}
    	public void internalEntityDecl (String name, String value) throws SAXException{}
        public  void externalEntityDecl (String name, String publicId,String systemId) throws SAXException {}
	 public void error(SAXParseException ex) {
 	LogFile.println(ex);
 	this.exception=ex;
       		_message=new String("[Warning] Ligne:"+(new Integer(ex.getLineNumber())).toString()+ex.getMessage());
       		_error=true;
 	}
       public void fatalError(SAXParseException ex)  
 	{
 		this.exception=exception;
	 LogFile.println(ex);
       	_message=new String("[Warning] Ligne:"+(new Integer(ex.getLineNumber())).toString()+ex.getMessage());
       	_error=true;	
	 }

	public void warning(SAXParseException ex)  {
		LogFile.println(ex);
		this.exception=exception;
       		_message=new String("[Warning] Ligne:"+(new Integer(ex.getLineNumber())).toString()+ex.getMessage());
       		_error=true;
    	}
}
/**
 * permet de tester du Xml
 * @param : filename le text Xml
 * @param : header la taille du header Xml
 * @param : strict validation strict ?
 * @result: le resultat du parsing
 */
public  XmlCheckerInformation TestXml(String filename,int header,boolean strict)
{DTDValid handler = new DTDValid();
try
{
XMLReader parser = (XMLReader)Class.forName(DEFAULT_PARSER_NAME).newInstance();
InputSource buff=new InputSource(new StringBufferInputStream(filename));
 // parser.setProperty( "http://xml.org/sax/properties/declaration-handler",new DTDValid());

     parser.setFeature( "http://xml.org/sax/features/validation",
                                                strict);
            parser.setFeature( "http://xml.org/sax/features/namespaces",
                                                strict );
            parser.setFeature( "http://apache.org/xml/features/validation/schema",
                                                strict );
            parser.setFeature( "http://apache.org/xml/features/validation/schema-full-checking",
                                                strict );

      

     parser.setContentHandler(handler);
     parser.setErrorHandler(handler);                                           
   parser.parse( buff );
}
catch (SAXParseException e)
{
	XmlCheckerInformation result=new XmlCheckerInformation(e.getLineNumber()-header,e.getColumnNumber(),e.getMessage());
	return result;
}
catch (Exception ee)
{ 
	XmlCheckerInformation result=new XmlCheckerInformation(0,0,ee.getMessage());
	return result;
}
if (handler.IsError()){
	SAXParseException e=handler.getException();
	XmlCheckerInformation result=new XmlCheckerInformation(e.getLineNumber()-header,e.getColumnNumber(),e.getMessage());
	
	return result;}
	else return (new XmlCheckerInformation());
}

}