package xml;
import logique.*;
import tools.*;
import java.util.Vector;
/**
 * 12-05-03 <br>
 *
 * Represente un couple de balise Xml<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 *
 * La classe XmlNode sert a la generation du document XML<br>
 * Elle represente un tableau de Balise Node 
 * ordonne en fonction de leur apparition dans le texte
 */
public class XmlNode
{


private BaliseNode [] _node;
private String printBaliseNode(BaliseNode[] t)
{
for (int i=0;i<t.length;i++)
LogFile.println(t[i]);
return "";
}
/**
 * constructeur
 */
public XmlNode()
{}
private void swap(Object [] tab,int index1,int index2)
{
Object tmp=tab[index1];
tab[index1]=tab[index2];
tab[index2]=tmp;
}
private BaliseNode[] sort(BaliseNode[] bnode)
{
int taille=bnode.length;
boolean change=true;
while(change)
{
change=false;
for (int i=0;i<taille-1;i++)
{
if (bnode[i].getIndex()>bnode[i+1].getIndex()) {swap(bnode,i,i+1);change=true;}
}
}

return (bnode);
}

private BaliseNode[] sort2(BaliseNode[] bnode)
{
int taille=bnode.length;
boolean change=true;
while(change)
{
change=false;
for (int i=0;i<taille-1;i++)
{
if (bnode[i].getIndex()<bnode[i+1].getIndex()) {swap(bnode,i,i+1);change=true;}
}
}

return (bnode);
}
/**
 * renvoie le tableau de balise node ordonne
 */
public BaliseNode[] getNode(){return _node;}
/**
 * initialise l'objet avec la liste des tag 
 * et cree le tableau de balise node
 */
 private int whereis (BaliseNode [] tab,BaliseNode node)
 {
 for (int i=0;i<tab.length;i++)
 if (tab[i].equals(node)) return i;
 return 0;
}
/**
 * Permet de genere le tableau de balise Xml ordonne ,
 * @param tag : la liste des tag
 * @param dtdtree: l arbre de DTD
 */
public void Init(ListeTag tag,DTDTree dtdtree)
{
int taile=tag.size();
BaliseNode un;
BaliseNode deux;
Tag t;
_node=new BaliseNode[taile*2];
int in=0;
for (int i=0;i<taile;i++)
{
t=tag.get(i);
un=new BaliseNode(t,true);
deux=new BaliseNode(t,false);
un.SetSoeur(deux);
deux.SetSoeur(un);
_node[in++]=un;
_node[in++]=deux;
}
LogFile.println("XmlNode l:87 _node"+printBaliseNode(_node));

BaliseNode[] toCheck=sort(_node);
LogFile.println("XmlNode l:90 _check"+printBaliseNode(toCheck));

//BaliseNode[] toCheck2=sort2(_node);

int taille =toCheck.length;
int index=0;
boolean change=true;

while(change)
{change=false;
printBaliseNode(toCheck);
for (index=0;index<(taille-1);index++)
{
	if (toCheck[index].getIndex()==toCheck[index+1].getIndex()
	  && toCheck[index].getSoeur().getIndex()!=toCheck[index+1].getSoeur().getIndex())
	{
		if (toCheck[index].IsDebut() && toCheck[index+1].IsDebut())
		{
		if (toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex())
		{LogFile.println("condition1 On Swappe "+index+" et "+(index+1)+" condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		swap(toCheck,index,index+1);change=true;index=0;
		LogFile.println("apres swap condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		}
	}
		else
		if (!toCheck[index].IsDebut() && !toCheck[index+1].IsDebut())
		{
		if (toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex())
		{LogFile.println("condition 2 On Swappe "+index+" et "+(index+1)+" condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		swap(toCheck,index,index+1);change=true;index=0;
		LogFile.println("apres swap condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		}
		else 
		if (toCheck[index].IsDebut() && !toCheck[index+1].IsDebut())
		{LogFile.println("condition 3 On Swappe "+index+" et "+(index+1));
		swap(toCheck,index,index+1);change=true;index=0;
		}
	}
		
	}
	

}
printBaliseNode(toCheck);
change=true;
while(change)
{
	change=false;
	for (index=0;index<(taille-1);index++)
	{
	if (toCheck[index].getIndex()==toCheck[index+1].getIndex()
		  && toCheck[index].getSoeur().getIndex()==toCheck[index+1].getSoeur().getIndex())
		  {
		   if (toCheck[index].IsDebut() 
			   && toCheck[index+1].IsDebut()
			   && !toCheck[index].getSoeur().IsDebut()
			   && !toCheck[index+1].getSoeur().IsDebut())
			   //est t on dans un monde merdique 
			   {
			   int m1=0;
			     for (m1=0;m1<_node.length;m1++) if (toCheck[m1].equals(toCheck[index].getSoeur())) break;
			     int m2=0;
			     for (m2=0;m1<_node.length;m2++) if (toCheck[m2].equals(toCheck[index+1].getSoeur())) break;
			 if (m2>m1) // et oui
				     {
				     LogFile.println("cas DTD de xmlNode");
				     LogFile.print(_node[index].getTag().getBalise().getName());
				     LogFile.print(_node[index].getTag().getBalise().getOrder());
				     LogFile.println(dtdtree.getUnder(_node[index].getTag().getBalise().getName()));
				     LogFile.print(_node[index+1].getTag().getBalise().getName());
				     LogFile.print(_node[index+1].getTag().getBalise().getOrder());
				    
				     LogFile.println(dtdtree.getUnder(_node[index+1].getTag().getBalise().getName()));
				      if (_node[index].getTag().getBalise().getOrder()
				       > _node[index+1].getTag().getBalise().getOrder())
				        { 
				  // a la lecture de la dtd il semblerait qu'il faille inverser
				         swap(toCheck,index,index+1);change=true;}
				         else 	{swap(toCheck,m1,m2);change=true;}
				     }
			   }
		  }
	}
}

}
_node=toCheck;

}

/**
 * renvoie la liste des tag ordonne
 */ 
public ListeTag toListeTag()
{
int taille=_node.length;
ListeTag result=new ListeTag();
for (int i=0;i<taille;i++)
{
if (_node[i].IsDebut()) result.add(_node[i].getTag());
}
return result;

}
/**
 * pour le debug
 */
public String toString()
{
String result=new String();
for (int i=0;i<_node.length;i++)
{
result=result+","+_node[i].toString();
}
return result;
}


}
