package myEvent;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
/**
 * 12-05-03 <br>
 *
 * evenement de changement de font<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * encapsule un changement de font
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 * 
 */
public class FontPanelEvent extends AWTEvent {
    SimpleAttributeSet request;
    // Event id must be greater than RESERVED_ID_MAX
    static final int BUTTON_CLICK_EVENT = AWTEvent.RESERVED_ID_MAX+100;
String _exemple;
    /**
     * evenement de changement de font 
     * @param source la source du panneau ayant genere l evenement
     * @param request la nouvelle font
     */
    public FontPanelEvent(Object source, SimpleAttributeSet request) {
        super(source, BUTTON_CLICK_EVENT);
        this.request = request;
        consumed = true;  // semantic event need not go to peer
        _exemple=null;
    }
    /**
     * evenement de changement de font 
     * @param source le panneau ayant genere l evenement
     * @param exemple un texte d exemple
     * @param request la nouvelle font
     */
public FontPanelEvent(Object source, String exemple,SimpleAttributeSet request) {
        this(source,request);
    _exemple=new String(exemple);
}
	/**
	 * renvoie la nouvelle font
	 * @result la nouvelle font
	 */
    public SimpleAttributeSet getAttribute() {
        return request;
    }
    /**
     * renvoie un texte exemple
     * @result le texte exemple ou null
     */
    public String getExemple(){return _exemple;}
    public String paramString() {
        return getAttribute() + super.paramString();
    }
}